<html><head><META http-equiv="Content-Type" content="text/html; charset=UTF-8"><title>Maven Publishing (new) - Gradle User Guide Version 4.2</title><link xmlns:xslthl="http://xslthl.sf.net" type="text/css" rel="stylesheet" href="base.css"><link xmlns:xslthl="http://xslthl.sf.net" type="text/css" rel="stylesheet" href="docs.css"><link xmlns:xslthl="http://xslthl.sf.net" type="text/css" rel="stylesheet" href="userguide.css"><meta content="DocBook XSL Stylesheets V1.75.2" name="generator"><link rel="home" href="userguide.html" title="Gradle User Guide Version 4.2"><link rel="up" href="pt03.html" title="Part&nbsp;III.&nbsp;Writing Gradle build scripts"><link rel="prev" href="publishing_ivy.html" title="Ivy Publishing (new) - Gradle User Guide Version 4.2"><link rel="next" href="distribution_plugin.html" title="The Distribution Plugin - Gradle User Guide Version 4.2"></head><body><div class="navheader"><div><div class="navbar"><a xmlns:xslthl="http://xslthl.sf.net" href="publishing_ivy.html" title="Ivy Publishing (new) - Gradle User Guide Version 4.2">Previous</a><span>|</span><a xmlns:xslthl="http://xslthl.sf.net" href="userguide.html" title="Gradle User Guide Version 4.2">Contents</a><span>|</span><a xmlns:xslthl="http://xslthl.sf.net" href="distribution_plugin.html" title="The Distribution Plugin - Gradle User Guide Version 4.2">Next</a></div></div></div><div class="chapter"><div class="titlepage"><div><div><h1 xmlns:xslthl="http://xslthl.sf.net"><a name="publishing_maven"></a>Chapter&nbsp;36.&nbsp;Maven Publishing (new)</h1></div></div></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="section"><a href="publishing_maven.html#sec:the_mavenpublish_plugin">36.1. The &ldquo;<code class="literal">maven-publish</code>&rdquo; Plugin</a></span></dt><dt><span class="section"><a href="publishing_maven.html#publishing_maven:publications">36.2. Publications</a></span></dt><dt><span class="section"><a href="publishing_maven.html#publishing_maven:repositories">36.3. Repositories</a></span></dt><dt><span class="section"><a href="publishing_maven.html#publishing_maven:publishing">36.4. Performing a publish</a></span></dt><dt><span class="section"><a href="publishing_maven.html#publishing_maven:install">36.5. Publishing to Maven Local</a></span></dt><dt><span class="section"><a href="publishing_maven.html#publishing_maven:generate-pom">36.6. Generating the POM file without publishing</a></span></dt></dl></div><div class="note"><p>
            This chapter describes the new <a class="link" href="feature_lifecycle.html">incubating</a> Maven publishing support provided by the &ldquo;<code class="literal">maven-publish</code>&rdquo;
            plugin. Eventually this new publishing support will replace publishing via the <code class="literal">Upload</code> task.
        </p><p>
            <span class="emphasis"><em>Note:</em></span> Signing the generated POM file generated by this plugin is currently not supported. Future versions of Gradle might add this functionality.
            Please use the <a class="link" href="maven_plugin.html">Maven plugin</a> for the purpose of publishing your artifacts to Maven Central.
        </p><p>
            If you are looking for documentation on the original Maven publishing support using the <code class="literal">Upload</code> task please see
            <a class="xref" href="artifact_management.html">Chapter&nbsp;32, <i>Publishing artifacts</i></a>.
        </p></div><p>
        This chapter describes how to publish build artifacts to an <a class="ulink" href="http://maven.apache.org/" target="_top">Apache Maven</a> Repository.
        A module published to a Maven repository can be consumed by Maven, Gradle (see <a class="xref" href="dependency_management.html">Chapter&nbsp;25, <i>Dependency Management</i></a>) and other tools that understand the Maven repository format.
    </p><div class="section"><div class="titlepage"><div><div><h2 class="title"><a xmlns:xslthl="http://xslthl.sf.net" name="sec:the_mavenpublish_plugin" class="section-anchor" href="#sec:the_mavenpublish_plugin"></a>36.1.&nbsp;The &ldquo;<code class="literal">maven-publish</code>&rdquo; Plugin</h2></div></div></div><p>
            The ability to publish in the Maven format is provided by the &ldquo;<code class="literal">maven-publish</code>&rdquo; plugin.
        </p><p>
            The &ldquo;<code class="literal">publishing</code>&rdquo; plugin creates an extension on the project named &ldquo;<code class="literal">publishing</code>&rdquo; of type <a class="ulink" href="../dsl/org.gradle.api.publish.PublishingExtension.html" target="_top"><code class="classname">PublishingExtension</code></a>.
            This extension provides a container of named publications and a container of named repositories. The &ldquo;<code class="literal">maven-publish</code>&rdquo; plugin works with
            <a class="ulink" href="../dsl/org.gradle.api.publish.maven.MavenPublication.html" target="_top"><code class="classname">MavenPublication</code></a> publications and <a class="ulink" href="../dsl/org.gradle.api.artifacts.repositories.MavenArtifactRepository.html" target="_top"><code class="classname">MavenArtifactRepository</code></a> repositories.
        </p><div class="example"><a xmlns:xslthl="http://xslthl.sf.net" name="publishing_maven:apply_plugin"></a><p class="title"><b>Example&nbsp;36.1.&nbsp;Applying the 'maven-publish' plugin</b></p><div class="example-contents"><p><code class="filename">build.gradle</code></p><pre class="programlisting">apply plugin: <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'maven-publish'</span>
</pre></div></div><br class="example-break"><p>
            Applying the &ldquo;<code class="literal">maven-publish</code>&rdquo; plugin does the following:
        </p><div class="itemizedlist"><ul class="itemizedlist"><li class="listitem">Applies the &ldquo;<code class="literal">publishing</code>&rdquo; plugin
            </li><li class="listitem">
                Establishes a rule to automatically create a <a class="ulink" href="../dsl/org.gradle.api.publish.maven.tasks.GenerateMavenPom.html" target="_top"><code class="classname">GenerateMavenPom</code></a>
                task for each <a class="ulink" href="../dsl/org.gradle.api.publish.maven.MavenPublication.html" target="_top"><code class="classname">MavenPublication</code></a> added (see <a class="xref" href="publishing_maven.html#publishing_maven:publications">Section&nbsp;36.2, &ldquo;Publications&rdquo;</a>).
            </li><li class="listitem">
                Establishes a rule to automatically create a <a class="ulink" href="../dsl/org.gradle.api.publish.maven.tasks.PublishToMavenRepository.html" target="_top"><code class="classname">PublishToMavenRepository</code></a> task
                for the combination of each <a class="ulink" href="../dsl/org.gradle.api.publish.maven.MavenPublication.html" target="_top"><code class="classname">MavenPublication</code></a> added (see <a class="xref" href="publishing_maven.html#publishing_maven:publications">Section&nbsp;36.2, &ldquo;Publications&rdquo;</a>),
                with each <a class="ulink" href="../dsl/org.gradle.api.artifacts.repositories.MavenArtifactRepository.html" target="_top"><code class="classname">MavenArtifactRepository</code></a> added (see <a class="xref" href="publishing_maven.html#publishing_maven:repositories">Section&nbsp;36.3, &ldquo;Repositories&rdquo;</a>).
            </li><li class="listitem">
                Establishes a rule to automatically create a <a class="ulink" href="../javadoc/org/gradle/api/publish/maven/tasks/PublishToMavenLocal.html" target="_top"><code class="classname">PublishToMavenLocal</code></a> task
                for each <a class="ulink" href="../dsl/org.gradle.api.publish.maven.MavenPublication.html" target="_top"><code class="classname">MavenPublication</code></a> added (see<a class="xref" href="publishing_maven.html#publishing_maven:publications">Section&nbsp;36.2, &ldquo;Publications&rdquo;</a>).
            </li></ul></div></div><div class="section"><div class="titlepage"><div><div><h2 class="title"><a xmlns:xslthl="http://xslthl.sf.net" name="publishing_maven:publications" class="section-anchor" href="#publishing_maven:publications"></a>36.2.&nbsp;Publications</h2></div></div></div><div class="note"><p>
                If you are not familiar with project artifacts and configurations, you should read the <a class="xref" href="artifact_management.html">Chapter&nbsp;32, <i>Publishing artifacts</i></a>
                that introduces these concepts. This chapter also describes &ldquo;publishing artifacts&rdquo; using a different mechanism than what is
                described in this chapter. The publishing functionality described here will eventually supersede that functionality.
            </p></div><p>
            Publication objects describe the structure/configuration of a publication to be created. Publications are published to repositories via tasks, and the
            configuration of the publication object determines exactly what is published. All of the publications of a project are defined in the
            <a class="ulink" href="../dsl/org.gradle.api.publish.PublishingExtension.html#org.gradle.api.publish.PublishingExtension:publications" target="_top"><code class="classname">PublishingExtension.getPublications()</code></a> container. Each publication has a unique name within the project.
        </p><p>
            For the &ldquo;<code class="literal">maven-publish</code>&rdquo; plugin to have any effect, a <a class="ulink" href="../dsl/org.gradle.api.publish.maven.MavenPublication.html" target="_top"><code class="classname">MavenPublication</code></a> must be added to the set of publications.
            This publication determines which artifacts are actually published as well as the details included in the associated POM file.
            A publication can be configured by adding components, customizing artifacts, and by modifying the generated POM file directly.
        </p><div class="section"><div class="titlepage"><div><div><h3 class="title"><a xmlns:xslthl="http://xslthl.sf.net" name="sec:publishing_component_to_maven" class="section-anchor" href="#sec:publishing_component_to_maven"></a>36.2.1.&nbsp;Publishing a Software Component</h3></div></div></div><p>
                The simplest way to publish a Gradle project to a Maven repository is to specify a <a class="ulink" href="../javadoc/org/gradle/api/component/SoftwareComponent.html" target="_top"><code class="classname">SoftwareComponent</code></a> to publish.
                The components presently available for publication are:
            </p><div xmlns:xslthl="http://xslthl.sf.net" class="table"><p class="title"><b>Table&nbsp;36.1.&nbsp;Software Components</b></p><div class="table-contents"><table id="N1511C"><thead><tr>
                        <td>Name</td>
                        <td>Provided By</td>
                        <td>Artifacts</td>
                        <td>Dependencies</td>
                    </tr></thead><tr>
                    <td><code class="literal">java</code></td>
                    <td><a class="xref" href="java_plugin.html">Chapter&nbsp;47, <i>The Java Plugin</i></a></td>
                    <td>Generated jar file</td>
                    <td>Dependencies from 'runtime' configuration</td>
                </tr><tr>
                    <td><code class="literal">web</code></td>
                    <td><a class="xref" href="war_plugin.html">Chapter&nbsp;50, <i>The War Plugin</i></a></td>
                    <td>Generated war file</td>
                    <td>No dependencies</td>
                </tr></table></div></div><p>
                 In the following example, artifacts and runtime dependencies are taken from the `java` component, which is added by the <code class="literal">Java Plugin</code>.
             </p><div class="example"><a xmlns:xslthl="http://xslthl.sf.net" name="publishing_maven:publish-component"></a><p class="title"><b>Example&nbsp;36.2.&nbsp;Adding a MavenPublication for a Java component</b></p><div class="example-contents"><p><code class="filename">build.gradle</code></p><pre class="programlisting">publishing {
    publications {
        mavenJava(MavenPublication) {
            from components.java
        }
    }
}
</pre></div></div><br class="example-break"></div><div class="section"><div class="titlepage"><div><div><h3 class="title"><a xmlns:xslthl="http://xslthl.sf.net" name="sec:publishing_custom_artifacts_to_maven" class="section-anchor" href="#sec:publishing_custom_artifacts_to_maven"></a>36.2.2.&nbsp;Publishing custom artifacts</h3></div></div></div><p>
                It is also possible to explicitly configure artifacts to be included in the publication. Artifacts are commonly supplied as raw files, or as instances of
                <a class="ulink" href="../dsl/org.gradle.api.tasks.bundling.AbstractArchiveTask.html" target="_top"><code class="classname">AbstractArchiveTask</code></a> (e.g. Jar, Zip).
            </p><p>
                For each custom artifact, it is possible to specify the <code class="literal">extension</code> and <code class="literal">classifier</code> values to use for publication. Note that
                only one of the published artifacts can have an empty classifier, and all other artifacts must have a unique classifier/extension combination.
            </p><p>
                Configure custom artifacts as follows:
            </p><div class="example"><a xmlns:xslthl="http://xslthl.sf.net" name="publishing_maven:publish-custom-artifact"></a><p class="title"><b>Example&nbsp;36.3.&nbsp;Adding additional artifact to a MavenPublication</b></p><div class="example-contents"><p><code class="filename">build.gradle</code></p><pre class="programlisting">task sourceJar(type: Jar) {
    from sourceSets.main.allJava
}

publishing {
    publications {
        mavenJava(MavenPublication) {
            from components.java

            artifact sourceJar {
                classifier <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">"sources"</span>
            }
        }
    }
}
</pre></div></div><br class="example-break"><p>
                See the <a class="ulink" href="../dsl/org.gradle.api.publish.maven.MavenPublication.html" target="_top"><code class="classname">MavenPublication</code></a> class in the API documentation for more information about how artifacts can be customized.
            </p></div><div class="section"><div class="titlepage"><div><div><h3 class="title"><a xmlns:xslthl="http://xslthl.sf.net" name="sec:identity_values_in_the_generated_pom" class="section-anchor" href="#sec:identity_values_in_the_generated_pom"></a>36.2.3.&nbsp;Identity values in the generated POM</h3></div></div></div><p>
                The attributes of the generated <code class="literal">POM</code> file will contain identity values derived from the following project properties:
            </p><div class="itemizedlist"><ul class="itemizedlist"><li class="listitem"><code class="literal">groupId</code> - <a class="ulink" href="../dsl/org.gradle.api.Project.html#org.gradle.api.Project:group" target="_top"><code class="classname">Project.getGroup()</code></a></li><li class="listitem"><code class="literal">artifactId</code> - <a class="ulink" href="../dsl/org.gradle.api.Project.html#org.gradle.api.Project:name" target="_top"><code class="classname">Project.getName()</code></a></li><li class="listitem"><code class="literal">version</code> - <a class="ulink" href="../dsl/org.gradle.api.Project.html#org.gradle.api.Project:version" target="_top"><code class="classname">Project.getVersion()</code></a></li></ul></div><p>
                Overriding the default identity values is easy: simply specify the <code class="literal">groupId</code>, <code class="literal">artifactId</code>
                or <code class="literal">version</code> attributes when configuring the <code class="literal">MavenPublication</code>.
            </p><div class="example"><a xmlns:xslthl="http://xslthl.sf.net" name="publishing_maven:publish-customize-identity"></a><p class="title"><b>Example&nbsp;36.4.&nbsp;customizing the publication identity</b></p><div class="example-contents"><p><code class="filename">build.gradle</code></p><pre class="programlisting">publishing {
    publications {
        maven(MavenPublication) {
            groupId <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'org.gradle.sample'</span>
            artifactId <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'project1-sample'</span>
            version <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'1.1'</span>

            from components.java
        }
    }
}
</pre></div></div><br class="example-break"><div class="tip">
                Certain repositories will not be able to handle all supported characters.
                For example, the ':' character cannot be used as an identifier when publishing to a filesystem-backed repository on Windows.
            </div><p>
                Maven restricts 'groupId' and 'artifactId' to a limited character set (<code class="literal">[A-Za-z0-9_\\-.]+</code>) and Gradle enforces this restriction.
                For 'version' (as well as artifact 'extension' and 'classifier'), Gradle will handle any valid Unicode character.
            </p><p>
                The only Unicode values that are explicitly prohibited are '<code class="literal">\</code>', '<code class="literal">/</code>' and any ISO control character.
                Supplied values are validated early in publication.
            </p></div><div class="section"><div class="titlepage"><div><div><h3 class="title"><a xmlns:xslthl="http://xslthl.sf.net" name="sec:modifying_the_generated_pom" class="section-anchor" href="#sec:modifying_the_generated_pom"></a>36.2.4.&nbsp;Modifying the generated POM</h3></div></div></div><p>
                The generated POM file may need to be tweaked before publishing. The &ldquo;<code class="literal">maven-publish</code>&rdquo;
                plugin provides a hook to allow such modification.
            </p><div class="example"><a xmlns:xslthl="http://xslthl.sf.net" name="publishing_maven:pom_modification"></a><p class="title"><b>Example&nbsp;36.5.&nbsp;Modifying the POM file</b></p><div class="example-contents"><p><code class="filename">build.gradle</code></p><pre class="programlisting">publications {
    mavenCustom(MavenPublication) {
        pom.withXml {
            asNode().appendNode(<span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'description'</span>,
                                <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'A demonstration of maven POM customization'</span>)
        }
    }
}
</pre></div></div><br class="example-break"><p>
                In this example we are adding a 'description' element for the generated POM. With this hook, you can modify any aspect of the POM.
                For example, you could replace the version range for a dependency with the actual version used to produce the build.
            </p><p>
                See <a class="ulink" href="../dsl/org.gradle.api.publish.maven.MavenPom.html#org.gradle.api.publish.maven.MavenPom:withXml(org.gradle.api.Action)" target="_top"><code class="classname">MavenPom.withXml(org.gradle.api.Action)</code></a> in the API documentation for more information.
            </p><p>
                It is possible to modify virtually any aspect of the created POM.
                This means that it is also possible to modify the POM in such a way that it is no longer a valid
                Maven POM, so care must be taken when using this feature.
            </p><p>
                The identifier (groupId, artifactId, version) of the published module is an exception; these values cannot be modified in the POM using the `withXML` hook.
            </p></div><div class="section"><div class="titlepage"><div><div><h3 class="title"><a xmlns:xslthl="http://xslthl.sf.net" name="sec:publishing_multiple_modules_to_maven" class="section-anchor" href="#sec:publishing_multiple_modules_to_maven"></a>36.2.5.&nbsp;Publishing multiple modules</h3></div></div></div><p>
                 Sometimes it's useful to publish multiple modules from your Gradle build, without creating a separate Gradle subproject.
                 An example is publishing a separate API and implementation jar for your library. With Gradle this is simple:
             </p><div class="example"><a xmlns:xslthl="http://xslthl.sf.net" name="publishing_maven:publish-multiple-publications"></a><p class="title"><b>Example&nbsp;36.6.&nbsp;Publishing multiple modules from a single project</b></p><div class="example-contents"><p><code class="filename">build.gradle</code></p><pre class="programlisting">task apiJar(type: Jar) {
    baseName <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">"publishing-api"</span>
    from sourceSets.main.output
    exclude <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'**/impl/**'</span>
}

publishing {
    publications {
        impl(MavenPublication) {
            groupId <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'org.gradle.sample.impl'</span>
            artifactId <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'project2-impl'</span>
            version <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'2.3'</span>

            from components.java
        }
        api(MavenPublication) {
            groupId <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'org.gradle.sample'</span>
            artifactId <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'project2-api'</span>
            version <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'2'</span>

            artifact apiJar
        }
    }
}
</pre></div></div><br class="example-break"><p>
                 If a project defines multiple publications then Gradle will publish each of these to the defined repositories. Each publication
                 must be given a unique identity as described above.
             </p></div></div><div class="section"><div class="titlepage"><div><div><h2 class="title"><a xmlns:xslthl="http://xslthl.sf.net" name="publishing_maven:repositories" class="section-anchor" href="#publishing_maven:repositories"></a>36.3.&nbsp;Repositories</h2></div></div></div><p>
            Publications are published to repositories. The repositories to publish to are defined by the <a class="ulink" href="../dsl/org.gradle.api.publish.PublishingExtension.html#org.gradle.api.publish.PublishingExtension:repositories" target="_top"><code class="classname">PublishingExtension.getRepositories()</code></a>
            container.
        </p><div class="example"><a xmlns:xslthl="http://xslthl.sf.net" name="publishing_maven:repositories"></a><p class="title"><b>Example&nbsp;36.7.&nbsp;Declaring repositories to publish to</b></p><div class="example-contents"><p><code class="filename">build.gradle</code></p><pre class="programlisting">publishing {
    repositories {
        maven {
            <span xmlns:xslthl="http://xslthl.sf.net" class="hl-comment">// change to point to your repo, e.g. http://my.org/repo</span>
            url <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">"$buildDir/repo"</span>
        }
    }
}
</pre></div></div><br class="example-break"><p>
            The DSL used to declare repositories for publication is the same DSL that is used to declare repositories to consume dependencies from,
            <a class="ulink" href="../dsl/org.gradle.api.artifacts.dsl.RepositoryHandler.html" target="_top"><code class="classname">RepositoryHandler</code></a>. However, in the context of Maven publication only
            <a class="ulink" href="../dsl/org.gradle.api.artifacts.repositories.MavenArtifactRepository.html" target="_top"><code class="classname">MavenArtifactRepository</code></a> repositories can be used for publication.
        </p></div><div class="section"><div class="titlepage"><div><div><h2 class="title"><a xmlns:xslthl="http://xslthl.sf.net" name="publishing_maven:publishing" class="section-anchor" href="#publishing_maven:publishing"></a>36.4.&nbsp;Performing a publish</h2></div></div></div><p>
            The &ldquo;<code class="literal">maven-publish</code>&rdquo; plugin automatically creates a <a class="ulink" href="../dsl/org.gradle.api.publish.maven.tasks.PublishToMavenRepository.html" target="_top"><code class="classname">PublishToMavenRepository</code></a>
            task for each <a class="ulink" href="../dsl/org.gradle.api.publish.maven.MavenPublication.html" target="_top"><code class="classname">MavenPublication</code></a> and <a class="ulink" href="../dsl/org.gradle.api.artifacts.repositories.MavenArtifactRepository.html" target="_top"><code class="classname">MavenArtifactRepository</code></a>
            combination in the <code class="literal">publishing.publications</code> and <code class="literal">publishing.repositories</code> containers respectively.
        </p><p>
            The created task is named &ldquo;<code class="literal">publish&laquo;<span class="emphasis"><em>PUBNAME</em></span>&raquo;PublicationTo&laquo;<span class="emphasis"><em>REPONAME</em></span>&raquo;Repository</code>&rdquo;.
        </p><div class="example"><a xmlns:xslthl="http://xslthl.sf.net" name="publishingMavenPublishMinimal"></a><p class="title"><b>Example&nbsp;36.8.&nbsp;Publishing a project to a Maven repository</b></p><div class="example-contents"><p><code class="filename">build.gradle</code></p><pre class="programlisting">apply plugin: <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'java'</span>
apply plugin: <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'maven-publish'</span>

group = <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'org.gradle.sample'</span>
version = <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">'1.0'</span>

publishing {
    publications {
        mavenJava(MavenPublication) {
            from components.java
        }
    }
}
publishing {
    repositories {
        maven {
            <span xmlns:xslthl="http://xslthl.sf.net" class="hl-comment">// change to point to your repo, e.g. http://my.org/repo</span>
            url <span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">"$buildDir/repo"</span>
        }
    }
}

</pre><p>Output of <strong class="userinput"><code>gradle publish</code></strong></p><pre class="screen">&gt; gradle publish
:generatePomFileForMavenJavaPublication
:compileJava
:processResources NO-SOURCE
:classes
:jar
:publishMavenJavaPublicationToMavenRepository
:publish

BUILD SUCCESSFUL in 0s
4 actionable tasks: 4 executed
</pre></div></div><br class="example-break"><p>
        	In this example, a task named &ldquo;<code class="literal">publishMavenJavaPublicationToMavenRepository</code>&rdquo; is created, which is of type
            <a class="ulink" href="../dsl/org.gradle.api.publish.maven.tasks.PublishToMavenRepository.html" target="_top"><code class="classname">PublishToMavenRepository</code></a>.
            This task is wired into the <code class="literal">publish</code> lifecycle task.
            Executing &ldquo;<code class="literal">gradle publish</code>&rdquo; builds the POM file and all of the artifacts to be published, and transfers them to the repository.
        </p></div><div class="section"><div class="titlepage"><div><div><h2 class="title"><a xmlns:xslthl="http://xslthl.sf.net" name="publishing_maven:install" class="section-anchor" href="#publishing_maven:install"></a>36.5.&nbsp;Publishing to Maven Local</h2></div></div></div><p>
            For integration with a local Maven installation, it is sometimes useful to publish the module into the local .m2 repository. In Maven parlance, this is
            referred to as 'installing' the module. The &ldquo;<code class="literal">maven-publish</code>&rdquo; plugin makes this easy to do by automatically creating a
            <a class="ulink" href="../javadoc/org/gradle/api/publish/maven/tasks/PublishToMavenLocal.html" target="_top"><code class="classname">PublishToMavenLocal</code></a> task for each <a class="ulink" href="../dsl/org.gradle.api.publish.maven.MavenPublication.html" target="_top"><code class="classname">MavenPublication</code></a>
            in the <code class="literal">publishing.publications</code> container. Each of these tasks is wired into the <code class="literal">publishToMavenLocal</code> lifecycle task.
            You do not need to have `mavenLocal` in your `publishing.repositories` section.
        </p><p>
            The created task is named &ldquo;<code class="literal">publish&laquo;<span class="emphasis"><em>PUBNAME</em></span>&raquo;PublicationToMavenLocal</code>&rdquo;.
        </p><div class="example"><a xmlns:xslthl="http://xslthl.sf.net" name="publishingMavenPublishLocal"></a><p class="title"><b>Example&nbsp;36.9.&nbsp;Publish a project to the Maven local repository</b></p><div class="example-contents"><p>Output of <strong class="userinput"><code>gradle publishToMavenLocal</code></strong></p><pre class="screen">&gt; gradle publishToMavenLocal
:generatePomFileForMavenJavaPublication
:compileJava
:processResources NO-SOURCE
:classes
:jar
:publishMavenJavaPublicationToMavenLocal
:publishToMavenLocal

BUILD SUCCESSFUL in 0s
4 actionable tasks: 4 executed
</pre></div></div><br class="example-break"><p>
            The resulting task in this example is named &ldquo;<code class="literal">publishMavenJavaPublicationToMavenLocal</code>&rdquo;. This task is wired into the <code class="literal">publishToMavenLocal</code> lifecycle task.
            Executing &ldquo;<code class="literal">gradle publishToMavenLocal</code>&rdquo; builds the POM file and all of the artifacts to be published, and &ldquo;installs&rdquo; them into the local Maven repository.
        </p></div><div class="section"><div class="titlepage"><div><div><h2 class="title"><a xmlns:xslthl="http://xslthl.sf.net" name="publishing_maven:generate-pom" class="section-anchor" href="#publishing_maven:generate-pom"></a>36.6.&nbsp;Generating the POM file without publishing</h2></div></div></div><p>
            At times it is useful to generate a Maven POM file for a module without actually publishing. Since POM generation is performed by a separate task, it is very easy
            to do so.
        </p><p>
            The task for generating the POM file is of type <a class="ulink" href="../dsl/org.gradle.api.publish.maven.tasks.GenerateMavenPom.html" target="_top"><code class="classname">GenerateMavenPom</code></a>, and it is given a name based on the name
            of the publication: &ldquo;<code class="literal">generatePomFileFor&laquo;<span class="emphasis"><em>PUBNAME</em></span>&raquo;Publication</code>&rdquo;. So in the example below,
            where the publication is named &ldquo;<code class="literal">mavenCustom</code>&rdquo;,
            the task will be named &ldquo;<code class="literal">generatePomFileForMavenCustomPublication</code>&rdquo;.
        </p><div class="example"><a xmlns:xslthl="http://xslthl.sf.net" name="publishingMavenGeneratePom"></a><p class="title"><b>Example&nbsp;36.10.&nbsp;Generate a POM file without publishing</b></p><div class="example-contents"><p><code class="filename">build.gradle</code></p><pre class="programlisting">model {
    tasks.generatePomFileForMavenCustomPublication {
        destination = file(<span xmlns:xslthl="http://xslthl.sf.net" class="hl-string">"$buildDir/generated-pom.xml"</span>)
    }
}
</pre><p>Output of <strong class="userinput"><code>gradle generatePomFileForMavenCustomPublication</code></strong></p><pre class="screen">&gt; gradle generatePomFileForMavenCustomPublication
:generatePomFileForMavenCustomPublication

BUILD SUCCESSFUL in 0s
1 actionable task: 1 executed
</pre></div></div><br class="example-break"><p>
            All details of the publishing model are still considered in POM generation, including <code class="literal">components</code>, custom <code class="literal">artifacts</code>,
            and any modifications made via <code class="literal">pom.withXml</code>.
        </p><div class="note"><p>
                The &ldquo;<code class="literal">maven-publish</code>&rdquo; plugin leverages some experimental support for late plugin configuration,
                and any <code class="literal">GenerateMavenPom</code> tasks will not be constructed until the publishing extension is configured.
                The simplest way to ensure that the publishing plugin is configured when you attempt to access the <code class="literal">GenerateMavenPom</code> task
                is to place the access inside a <code class="literal">model</code> block, as the example above demonstrates.
            </p><p>
                The same applies to any attempt to access publication-specific tasks like <a class="ulink" href="../dsl/org.gradle.api.publish.maven.tasks.PublishToMavenRepository.html" target="_top"><code class="classname">PublishToMavenRepository</code></a>.
                These tasks should be referenced from within a <code class="literal">model</code> block.
            </p></div></div></div><div class="navfooter"><div><div class="navbar"><a xmlns:xslthl="http://xslthl.sf.net" href="publishing_ivy.html" title="Ivy Publishing (new) - Gradle User Guide Version 4.2">Previous</a><span>|</span><a xmlns:xslthl="http://xslthl.sf.net" href="userguide.html" title="Gradle User Guide Version 4.2">Contents</a><span>|</span><a xmlns:xslthl="http://xslthl.sf.net" href="distribution_plugin.html" title="The Distribution Plugin - Gradle User Guide Version 4.2">Next</a></div></div></div></body></html>